class Animation {
  ArrayList<String> imgs;
  float tick_millis, last_millis;
  int phase;
  boolean stopped;
  
  Animation(ArrayList<String> _imgs, float _tick_millis) {
    imgs = _imgs;
    tick_millis = _tick_millis;
    last_millis = millis();
    phase = 0;
    stopped = false;
  }
  
  PImage ci() {
    if (!stopped) {
      while (millis() - tick_millis > last_millis) {
        last_millis += tick_millis;
        phase++;
        if (phase >= imgs.size()) {
          phase = 0;
        }
      }
    }
    return gt(imgs.get(phase));
  }
}

class FlowingAnimation {
  String name;
  float tick_millis, last_millis;
  int phase;
  FlowingAnimation(String _name, float _tick_millis){
    name = _name;
    tick_millis = _tick_millis;
    phase = 0;
  }
  
  PImage ci() {
    while (millis() - tick_millis > last_millis) {
      last_millis += tick_millis;
      phase++;
      if (phase >= 30) {
        phase = 0;
      }
    }
      
    return get_img();
  }
  
  PImage get_img() {
    PImage img = createImage(30, 30, ARGB);
    PImage main_img = gt(name);
    main_img.loadPixels();
    img.loadPixels();
    for (int i = 0; i < img.pixels.length; i++) {
      img.pixels[i] = main_img.pixels[i+30*phase];
    }
    main_img.updatePixels();
    img.updatePixels();
    
    return img;
  }
}