class TextureManager {
  //ArrayList<String> names;
  //ArrayList<PImage> textures;
  HashMap<String,PImage> textures;
  
  TextureManager() {
    //names = new ArrayList<String>();
    //textures = new ArrayList<PImage>();
    textures = new HashMap<String,PImage>();
    loadTextures();
  }
  
  void loadTextures() {
    String path = sketchPath();
    ArrayList<File> allFiles = listFilesRecursive(path);
    for (File f : allFiles) {
      if (f.getAbsolutePath().substring(f.getAbsolutePath().length()-4).equals(".png")) {
        //names.add(f.getAbsolutePath());
        String name = f.getAbsolutePath();
        textures.put(splitString(name), loadImage(name));
      }
    }
    
    //for (String name : names) {
    //  textures.add(loadImage(name));
    //}
    //println(textures.get("player_6.png"));
    //for (HashMap.Entry<String,PImage> entry : textures.entrySet()) {
    //  println(entry.getKey());
    //}
  }
    
  PImage get_texture(String texture_name) {
    //for (int i = 0; i < names.size(); i++) {
    //  if (splitString(names.get(i)).equals(texture_name)) {
    //    return textures.get(i);
    //  }
    //}
    //return null;
    
    //return textures.get(texture_name);
    PImage texture = textures.get(texture_name);
    //if (texture == null) {
    //  println(texture_name + " " + ("player_1.png".equals());
    //  exit();
    //}
    return texture;
  }

  
  void register_resize(String texture_name, String new_name, int w, int h) {
    new_name = "/"+new_name;
    //names.add(new_name);
    PImage new_img = get_texture(texture_name).get();
    new_img.resize(w, h);
    //textures.add(new_img);
    textures.put(new_name, new_img);
  }
  
  String splitString(String name) {
    String f_name = "error";
    for (int i = name.length()-1; i >= 0; i--) {
      if (name.charAt(i) == '/' || name.charAt(i) == '\\') {
        f_name = name.substring(i+1);
        break;
      }
    }
    return f_name;
  }
  
  ArrayList<File> listFilesRecursive(String dir) {
    ArrayList<File> fileList = new ArrayList<File>(); 
    recurseDir(fileList, dir);
    return fileList;
  }
  
  void recurseDir(ArrayList<File> a, String dir) {
    File file = new File(dir);
    if (file.isDirectory()) {
      a.add(file);  
      File[] subfiles = file.listFiles();
      for (int i = 0; i < subfiles.length; i++) {
        recurseDir(a, subfiles[i].getAbsolutePath());
      }
    } else {
      a.add(file);
    }
  }
}